package dev.peerat.parser.java.value;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.Operation;
import dev.peerat.parser.java.Variable;
import dev.peerat.parser.java.Operation.OperationContainer;
import dev.peerat.parser.java.Variable.VariableContainer;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.VisitorBag;

public class LambdaValue extends Value implements OperationContainer, VariableContainer{
	
	private List<Token> parameters;
	private List<JavaElement> operations;
	
	public LambdaValue(List<Token> parameters, List<JavaElement> operations){
		this.parameters = parameters;
		this.operations = operations;
	}
	
	public LambdaValue(List<Token> parameters, Value value){
		this.parameters = parameters;
		this.operations = new ArrayList<>();
		this.operations.add(value);
	}
	
	public List<Token> getParameters(){
		return this.parameters;
	}
	
	public List<JavaElement> getOperations(){
		return this.operations;
	}
	
	@Override
	public void addVariable(Variable variable){
		this.operations.add(variable);
	}

	@Override
	public void addOperation(Operation operation) {
		this.operations.add(operation);
	}

	@Override
	public void build(Builder builder) throws Exception {
		
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(JavaVisitor<?> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		for(JavaElement element : this.operations){
			bag.merge(element.visit(visitor));
		}
		return bag;
	}
	

}
